#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Odds2_Buff.h"
std::auto_ptr<Odds2_Buff> Odds2_Buff::msSingleton(nullptr);

int Odds2_Buff::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_BuffData* Odds2_Buff::GetData(int BuffID)
{
	auto it = mMapData.find(BuffID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Odds2_BuffData>& Odds2_Buff::GetMapData()
{
	return mMapData;
}

void Odds2_Buff::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Odds2_Buff.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_BuffData data;
		data.mBuffID = element->IntAttribute("BuffID");
		data.mThreshold = element->IntAttribute("Threshold");
		data.mBuffEffect = element->IntAttribute("BuffEffect");
		data.mBuffEffectMin = element->IntAttribute("BuffEffectMin");
		data.mBuffEffectMax = element->IntAttribute("BuffEffectMax");
		data.mBuffInviMin = element->IntAttribute("BuffInviMin");
		data.mBuffInviMax = element->IntAttribute("BuffInviMax");
		data.mSpecialFishMin = element->IntAttribute("SpecialFishMin");
		data.mSpecialFishMax = element->IntAttribute("SpecialFishMax");
		data.mBuffCount = element->IntAttribute("BuffCount");
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		CCASSERT(mMapData.find(data.mBuffID) == mMapData.end(), "data.mBuffID is exists");
		mMapData.insert(std::make_pair(data.mBuffID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Odds2_Buff Loaded. Load Data:%u", mMapData.size());
}

void Odds2_Buff::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Odds2_Buff");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Odds2_Buff");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Odds2_BuffData data;
		LuaCfgHelper::readInt(L, "BuffID", data.mBuffID);
		LuaCfgHelper::readInt(L, "Threshold", data.mThreshold);
		LuaCfgHelper::readInt(L, "BuffEffect", data.mBuffEffect);
		LuaCfgHelper::readInt(L, "BuffEffectMin", data.mBuffEffectMin);
		LuaCfgHelper::readInt(L, "BuffEffectMax", data.mBuffEffectMax);
		LuaCfgHelper::readInt(L, "BuffInviMin", data.mBuffInviMin);
		LuaCfgHelper::readInt(L, "BuffInviMax", data.mBuffInviMax);
		LuaCfgHelper::readInt(L, "SpecialFishMin", data.mSpecialFishMin);
		LuaCfgHelper::readInt(L, "SpecialFishMax", data.mSpecialFishMax);
		LuaCfgHelper::readInt(L, "BuffCount", data.mBuffCount);
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		CCASSERT(mMapData.find(data.mBuffID) == mMapData.end(), "data.mBuffID is exists");
		mMapData.insert(std::make_pair(data.mBuffID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Odds2_Buff Loaded. Load Data:%u", mMapData.size());
}

void Odds2_Buff::Reload()
{
	mMapData.clear();
	Load();
}

Odds2_Buff* Odds2_Buff::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_Buff());
	}
	return msSingleton.get();
}

void Odds2_Buff::Release()
{
	msSingleton.reset(nullptr);
}
